# -*- coding: utf-8 -*-
"""
Created on Wed Sep  7 11:27:45 2016

@author: akibdpt
"""
#element
from . import element

#sort folder as _sort to not be confused with sort module
from . import sort as _sort

#import all structures
from .struct.coordinate import coordinate
from .struct.vector import vector2D ,vector3D
from .struct.vectorFloat import vector2Dfloat, vector3Dfloat

#import all sorts
from .sort.sort import sort
from .sort.sorts import sorts
from .sort.simpleSort import simpleSort
from .sort.primitiveSort import primitiveSort
from .sort.attributeSort import attributeSort
from .sort.disjunctiveSort import disjunctiveSort
from .sort.parameter.argument import argument
from .sort.parameter.colorMode import colorMode

#import all maps >>>>>>>>>.
from .map.distinguishable import distinguishable
from .map.mapping import mapping
from .map.paramSet import paramSet
from .map.exactMap import exactMap
from .map.similarityMap import similarityMap2D, similarityMap3D
from .map.parametricMap import parametricMap

#import all transforms >>>>>>>>>>>
from .transform.transform import transform
from .transform.transformSet import transformSet
from .transform.affineTransform import affineTransform2D, affineTransform3D

#import all forms
from .form.form import form
from .form.multiplyForm import multiplyForm
from .form.singlyForm import singlyForm
from .form.areal import areal
from .form.discrete import discrete
from .form.ordinal import ordinal
from .form.interval import interval
from .form.coForm import coForm
from .form.metaForm import metaForm
from .form.specialForm import specialForm

#import all individuals
from .ind.individual import individual

from .ind.date import date
from .ind.enumerative import enumerative
from .ind.imageUrl import imageUrl
from .ind.label import label
from .ind.numeric import numeric
from .ind.url import url
from .ind.point import point2D, point3D

from .ind.weight import weight

from .ind.line import line2D, line3D
from .ind.lineSegment import lineSegment2D, lineSegment3D

from .ind.plane import plane2D, plane3D
from .ind.planeSegment import planeSegment2D
from .ind.planeSegment3D import planeSegment3D

#import all crossAlgebra
from .ind.crossAlgebra.crossAlgebraPlane import crossAlgebraPlane2D

#import all grammar
from .grammar.fragment import fragment
from .grammar.derivation import derivation
from .grammar.ruleAnalysis import ruleAnalysis
from .grammar.ruleApplication import ruleApplication
from .grammar.detection import detection
from .grammar.rule import rule
from .grammar.rules import rules


similarityMap = similarityMap2D
affineTransform = affineTransform2D

sortNames = sort.register

individualList = [vector2D, vector3D,
                  date, imageUrl, label, url, weight, numeric,
                  point2D, point3D, 
                  line2D, line3D, lineSegment2D, lineSegment3D,
                  plane2D, planeSegment2D,
                  enumerative]

#define all modules
__all__  = ["element", 
            
            #struct
            "coordinate", "vector2D", "vector2Dfloat", "vector3D", "vector3Dfloat",
            
            #sorts
            "sort", "sorts", "simpleSort", "primitiveSort", "attributeSort", 
            "disjunctiveSort", 
            "sortNames",
            
            #map
            "distinguishable", 
            "exactMap",
            "similarityMap2D", 'similarityMap3D', 'similarityMap',
            "parametricMap", "paramSet",
            
            #transform
            "transform", "transformSet", 
            "affineTransform", "affineTransform2D", "affineTransform3D",
            
            #forms
            "form", "multiplyForm", "singlyForm", "discrete", "ordinal", 
            "interval", "coForm","metaForm", 
            
            #individuals
            "individual", 
            "date", "imageUrl", "label", "url", "weight", "numeric",
            "point2D", "point3D", 
            "line2D", "line3D", "lineSegment2D", "lineSegment3D",
            "plane2D", "planeSegment2D",
            "enumerative", 
            
            "crossAlgebraPlane2D",
            
            #grammar
            "fragment", "derivation", "ruleAnalysis", "ruleApplication", "detection", "rule", "rules" ]



reg = [[date, discrete , argument.argumentType.LOCALE, exactMap, mapping.DISCRETE],
       [imageUrl, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       #[key, discrete , 'IDENTIFIER', exactMap, mapping.DISCRETE],
       [label, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       [numeric, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       [url, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       [weight, ordinal , argument.argumentType.UPPERBOUND, exactMap, mapping.LINEAR],

       [point2D, discrete , argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [point3D, discrete , argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],

       [line2D, discrete , argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [line3D, discrete , argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [lineSegment2D, interval , argument.argumentType.NONE, similarityMap2D, mapping.LINEAR],
       [lineSegment3D, interval , argument.argumentType.NONE, similarityMap3D, mapping.LINEAR],

       [plane2D, discrete, argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [plane3D, discrete, argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [planeSegment2D, coForm, argument.argumentType.NONE, similarityMap2D, mapping.PLANAR],
       [planeSegment3D, areal, argument.argumentType.NONE, similarityMap3D, mapping.PLANAR],

       [enumerative, specialForm, argument.argumentType.ENUMERATION, exactMap, mapping.DISCRETE],
       ]
for i in reg:
    primitiveSort.register(i[0],i[1],i[2],i[3],i[4])
    

reg = [[exactMap, 0],
       [similarityMap2D, 7],
       [similarityMap3D, 7],
       [parametricMap, 1]]
for i in reg:
    mapping.register(i[0],i[1])
