# -*- coding: utf-8 -*-
"""
Created on Fri Dec 23 12:09:56 2016

@author: akibdpt
"""
from .multiplyForm import multiplyForm
from .coForm import coForm

class areal(multiplyForm):
    
    def __init__(self, sort):
        super().__init__(sort)
        self.type = 'form-areal'
        
        
    def printE(self, string = ''):
        print(string + '|' + self.sort.name+' areal:',len(self.elements),'elements')
        for ind in self.elements:
            ind.printE(string+'   ')
        return
        
        
    def edit(self, editor):
        result = areal(self.sort)
        for element in self.elements:
            result.insert(element.edit(editor))
        return result
        
    """
    inserting an element into the form
    """
    def insert(self, plane):
        if plane.type == 'form-coForm':
            if not self.sort == plane.sort:
                raise ValueError('not of the same sort')
            thisCoForm = self.first()
            index = 0
            while thisCoForm is not None:
                if thisCoForm.compareValue(plane) == 0:
                    return
                elif thisCoForm.compareValue(plane) == 1:
                    self.add(index, plane)
                    return
                else: 
                    thisCoForm = self.next(thisCoForm)      
                    index = index+1
            self.add(index, plane)
            return
        else:
            
            if not self.sort == plane.sort:
                raise ValueError('not of the same sort')
            thisCoForm = self.first()
            index = 0
            while thisCoForm is not None:
                if thisCoForm.compareValuePlane(plane) == 0:
                    thisCoForm.insert(plane)
                    return
                elif thisCoForm.compareValuePlane(plane) == 1:
                    newcoForm = coForm(self.sort)
                    newcoForm.insert(plane)
                    self.add(index, newcoForm)
                    return
                else: 
                    thisCoForm = self.next(thisCoForm)      
                    index = index+1
            newcoForm = coForm(self.sort)
            newcoForm.insert(plane)
            self.add(index, newcoForm)
            return
                
    """
    maximalize the form:
    _remove Nil elements
    _reorder the elements in the form in ascending order
    """
    def maximalize(self):
        if self.maximal:
            return
    
        self.maximal = True
        
        if len(self.elements) == 0:
            return
        
        for coF in self.elements:
            coF.maximalize()          
        return
    
    """
    sum two forms (OR)
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.sum(formB)
      -->formA: a, b, c, d
    """
    def sum(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
        
        self.maximalize()
        other.maximalize()
        
        thisCoForm = self.first()
        otherCoForm = other.first()
        index = 0
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, sum
                thisCoForm.sum(otherCoForm)
                thisCoForm = self.next(thisCoForm)                            
                index = index+1
                otherCoForm = other.next(otherCoForm)
            elif thisCoForm.compareValue(otherCoForm) == 1:
                self.add(index, otherCoForm)                            
                index = index+1
                otherCoForm = other.next(otherCoForm)
            else:                          
                index = index+1
                thisCoForm =self.next(thisCoForm)       
        while otherCoForm is not None:
            self.add(index, otherCoForm)                            
            index = index+1
            otherCoForm = other.next(otherCoForm)
        return

    """
    difference of two forms
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.difference(formB)
      -->formA: a
    """
    def difference(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
        
        self.maximalize()
        other.maximalize()
            
        thisCoForm = self.first()
        otherCoForm = other.first()

        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, calculate difference
                thisCoForm.difference(otherCoForm)
                if len(thisCoForm.elements) == 0:
                    toBeRemovedInd = thisCoForm
                    thisCoForm = self.next(thisCoForm)
                    self.remove(toBeRemovedInd)
                otherCoForm = other.next(otherCoForm)
            elif thisCoForm.compareValue(otherCoForm) == 1:                            
                otherCoForm = other.next(otherCoForm)
            else:                             
                thisCoForm =self.next(thisCoForm)       
        return

    """
    product of two forms (AND)
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.product(formB)
      -->formA:    b, c
    """
    def product(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
                       
        thisCoForm = self.first()
        otherCoForm = other.first()
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, product
                thisCoForm.product(otherCoForm)
                if len(thisCoForm.elements) == 0:
                    toBeRemovedInd = thisCoForm
                    thisCoForm = self.next(thisCoForm)
                    self.remove(toBeRemovedInd)
                otherCoForm = other.next(otherCoForm)
            elif thisCoForm.compareValue(otherCoForm) == 1:                
                otherCoForm = other.next(otherCoForm)
            else:                             
                toBeRemovedInd = thisCoForm
                thisCoForm = self.next(thisCoForm)
                self.remove(toBeRemovedInd)
        while thisCoForm is not None:   
            toBeRemovedInd = thisCoForm
            thisCoForm = self.next(thisCoForm)
            self.remove(toBeRemovedInd)
        return

    """
    symdifference of two forms (XOR)
    e.g. formA: a, b, c
         formB:    b, c, d
        _formA.symdifference(formB)
      -->formA: a,       d
    """
    def symdifference(self,other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
                       
        thisCoForm = self.first()
        otherCoForm = other.first()
        index = 0
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                #if has attribute, calculate difference
                thisCoForm.symdifference(otherCoForm)
                if len(thisCoForm.elements) == 0:
                    toBeRemovedInd = thisCoForm
                    thisCoForm = self.next(thisCoForm)
                    self.remove(toBeRemovedInd)
                otherCoForm = other.next(otherCoForm)                
            elif thisCoForm.compareValue(otherCoForm) == 1:
                self.add(index, otherCoForm)                            
                index = index+1
                otherCoForm = other.next(otherCoForm)
            else:                             
                index = index+1
                thisCoForm =self.next(thisCoForm)       
        while otherCoForm is not None:
            self.add(index, otherCoForm)                            
            index = index+1
            otherCoForm = other.next(otherCoForm)
        return 

    """
    partition of two forms (XOR)
    e.g. formA: a, b, c
         formB:    b, c, d
         
        _common = formA.partition(formB)
      -->formA: a
         formB:          d
         common:   b, c
    """
    def partition(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
                       
        thisCoForm = self.first()
        otherCoForm = other.first()
        common = areal(self.sort)
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:      
                c = thisCoForm.partition(otherCoForm)
                if len(c.elements) != 0:
                    common.insert(c)
                if len(thisCoForm.elements) == 0:
                    toBeRemoved = thisCoForm
                    thisCoForm = self.next(thisCoForm)
                    self.remove(toBeRemoved)
                else:
                    thisCoForm =self.next(thisCoForm)     
                    
                if len(otherCoForm.elements) == 0:
                    toBeRemoved = otherCoForm
                    otherCoForm = other.next(otherCoForm)
                    other.remove(toBeRemoved)
                else:
                    otherCoForm = other.next(otherCoForm)
                
            elif thisCoForm.compareValue(otherCoForm) == 1:      
                otherCoForm = other.next(otherCoForm)
            else:                             
                thisCoForm =self.next(thisCoForm)       
        return common
        
    """
    check if this form is a part of other form
    """
    def partOf(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
            return
        if not self.sort.__eq__(other.sort):
            raise ValueError('not of the same sort')
            return
            
        self.maximalize()
        other.maximalize()
                       
        thisCoForm = self.first()
        otherCoForm = other.first()
        while thisCoForm is not None and otherCoForm is not None:
            if thisCoForm.compareValue(otherCoForm) == 0:
                if not thisCoForm.partOf(otherCoForm):
                    return False
                thisCoForm = self.next(thisCoForm)
                otherCoForm = other.next(otherCoForm)
                
            elif thisCoForm.compareValue(otherCoForm) == 1:
                otherCoForm = other.next(otherCoForm)
            else:                             
                return False
        return thisCoForm is None
        
    def convertFloat(self):
        result = self.sort.newForm()
        for i in self.elements:
            result.insert(i.convertFloat())
        result.maximal = self.maximal
        return result
        