# -*- coding: utf-8 -*-
"""
Created on Mon Nov  7 13:42:12 2016

@author: akibdpt
"""
from .multiplyForm import multiplyForm

class coForm(multiplyForm):
    def __init__(self, sort):
        super().__init__(sort)
        self.type = 'form-coForm'
        
    def insert(self, ind):
        
        if not self.sort == ind.sort:
            raise ValueError('not of the same sort')
        """
        thisInd = self.first()
        index = 0
        while thisInd is not None and thisInd.compareAreal(ind) < 1:
            if thisInd.compareAreal(ind) == 0:
                if thisInd.hasAttribute() or ind.hasAttribute():
                    thisInd.attribute.sum(ind.attribute)
                return
            else:
                thisInd = self.next(thisInd)
                index = index+1
        """
        self.add(0, ind)
    
    def printE(self, string = ''):
        print(string + '|' + self.sort.name+' coForm:',len(self.elements),'elements')
        for ind in self.elements:
            ind.printPlaneSegment(string)
            if ind.hasAttribute():
                ind.attribute.printE(string+'  ')
        return        
    
    def move(self, other):
        for element in self.elements:
            element.assoc = other
            
        other.elements = self.elements + other.elements
        self.elements.clear()
        other.maximal = False
        
    def copy(self, other):
        for element in other.elements:
            self.insert(element)
        self.maximal = False
        
    def coEquals(self, other):
        return self.first().coEquals(other.first())
        
    def compareValue(self, other):
        return self.first().compareValue(other.first())
        
    def compareValuePlane(self, other):
        return self.first().compareValue(other)
        
    def edit(self, editor):
        result = coForm(self.sort)
        for element in self.elements:
            result.insert(element.edit(editor))
        return result
        
    def maximalize(self, ignoreMaximal=False):
        if self.maximal and not ignoreMaximal:
            return
    
        self.maximal = True
        
        if len(self) <=1:
            return
        if self.sort.type == 'sort-attribute':
            subForms = []
            for i in self.elements:
                check = False
                for j in subForms:
                    if i.attribute == j.elements[0].attribute:
                        j.insert(i)
                        check = True
                        break
                if not check:
                    f = coForm(self.sort)
                    f.insert(i)
                    subForms.append(f)
                    
            self.clear()
            
            for i in subForms:
                element = i.pop(0)
                result = coForm(self.sort)
                one = coForm(self.sort)
                result.insert(element)
                while not i.isEmpty():
                    element = i.pop(0)
                    one.insert(element)
                    classes = element.classification(result, one)
                    if classes.disjoint():
                        one.remove(element)
                        result.insert(element)
                    elif classes.isContained():
                        result.clear()
                        one.remove(element)
                        result.insert(element)
                    elif classes.contains():
                        one.clear()
                    else:
                        one.clear()
                        result.clear()
                        element.construct(classes.sumSet(), result)
                result.move(i)
            
            result = []
            temp = []
            
            temp.append(subForms.pop(0))
            while len(subForms) != 0:
                two = subForms.pop(0)
                while len(temp)!=0 and not two.isEmpty():
                    one = temp.pop(0)
                    element = one.elements[0]
                    classes = element.classification(one,two)
                    if classes.disjoint() or classes.touches():
                        result.append(one)
                        one = None
                    elif element.attribute.partOf(element.attribute):
                        # update result by subtracting element from current
                        one.clear()
                        if not classes.isContained():
                            element.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(element.attribute)
                            result.append(one)
                            one = None

                    elif element.attribute.partOf(element.attribute):
                        result.append(one)
                        one = None
                        # update element by subtracting current
                        two.clear()
                        if not classes.contains():
                            element.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(element.attribute)
                            element = two.first()
                        
                    else:
                        one.clear()
                        if not classes.isContained():
                            # update result by subtracting element from current
                            element.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(element.attribute)
                                
                            result.append(ind)
                            one.clear()
                            # update result with the product of element and current
                            element.construct(classes.productSet(), one)
                        else:
                            one.insert(element.duplicate())
                        
                        attr = element.attribute.duplicate()
                        attr.sum(element.attribute)
                        element.clear()
                        while not one.isempty():
                            ind = one.first()
                            ind.addAttribute(attr)
                            
                        result.insert(one)
                        one.clear()
                        # update element by subtracting current
                        two.clear()
                        if not classes.contains():
                            element.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(element.attribute)
                            element = two.first()
                temp += result
                temp.append(two)
            for i in temp:
                self.elements += i.elements
        else:
            element = self.pop(0)
            result = coForm(self.sort)
            one = coForm(self.sort)
            result.insert(element)
            while not self.isEmpty():
                element = self.pop(0)
                one.insert(element)
                classes = element.classification(result, one)
                if classes.disjoint():
                    one.remove(element)
                    result.insert(element)
                elif classes.isContained():
                    result.clear()
                    one.remove(element)
                    result.insert(element)
                elif classes.contains():
                    one.clear()
                else:
                    one.clear()
                    result.clear()
                    element.construct(classes.sumSet(), result)
            result.move(self)
    

        for i in self.elements:
            for j in i.boundaries:
                j.maximalize()


    """
    def maximalize(self, ignoreMaximal=False):
        if self.maximal and not ignoreMaximal:
            return
    
        self.maximal = True
        
        if len(self) <=1:
            return
        element = self.pop(0)
        if element.sort.type == 'sort-attribute':
            result = coForm(self.sort)
            temp = coForm(self.sort)
            one = coForm(self.sort)
            two = coForm(self.sort)
            temp.insert(element)
            while not self.isEmpty():
                element = self.pop(0)
                two.insert(element)
                while (not temp.isEmpty()) and (not two.isEmpty()):
                    current = temp.pop(0)
                    one.insert(current)
                    classes = element.classification(one,two)
                    if classes.disjoint():
                        one.remove(current)
                        result.insert(current)
                    elif classes.touches():
                        if current.attribute == element.attribute:
                            two.clear()
                            element.construct(classes.sumSet(), two)
                            element = two.first()
                            for ind in two.elements:
                                ind.addAttribute(current.attribute)
                            one.clear()
                        else:
                            one.remove(current)
                            result.insert(current)
                    elif current.attribute == element.attribute:
                        two.clear()
                        element.construct(classes.sumSet(), two)
                        element = two.first()
                        for ind in two.elements:
                            ind.addAttribute(current.attribute)
                        one.clear()
                        
                    elif current.attribute.partOf(element.attribute):
                        # update result by subtracting element from current
                        one.remove(current)
                        if not classes.isContained():
                            element.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(current.attribute)
                                one.remove(ind)
                                result.insert(ind)
                        current.clear()

                    elif element.attribute.partOf(current.attribute):
                        one.remove(current)
                        result.insert(current)
                        # update element by subtracting current
                        two.remove(element)
                        two.clear()
                        if not classes.contains():
                            element.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(element.attribute)
                            element.clear()
                            element = two.first()
                        else:
                            element.clear()
                        
                    else:
                        one.remove(current)
                        if not classes.isContained():
                            # update result by subtracting element from current
                            element.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(current.attribute)
                                one.remove(ind)
                                result.insert(ind)
                            
                            # update result with the product of element and current
                            element.construct(classes.productSet(), one)
                        else:
                            one.insert(current.duplicate())
                        
                        attr = current.attribute.duplicate()
                        attr.sum(element.attribute)
                        current.clear()
                        while not one.isempty():
                            ind = one.first()
                            ind.addAttribute(attr)
                            one.remove(ind)
                            result.insert(ind)
                        
                        # update element by subtracting current
                        two.remove(element)
                        two.clear()
                        if not classes.contains():
                            element.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(element.attribute)
                            element.clear()
                            element = two.first()
                        else:
                            element.clear()
                result.move(temp)
                two.move(temp)
            temp.move(self)
        else:
            result = coForm(self.sort)
            one = coForm(self.sort)
            result.insert(element)
            while not self.isEmpty():
                element = self.pop(0)
                one.insert(element)
                classes = element.classification(result, one)
                if classes.disjoint():
                    one.remove(element)
                    result.insert(element)
                elif classes.isContained():
                    result.clear()
                    one.remove(element)
                    result.insert(element)
                elif classes.contains():
                    one.clear()
                else:
                    one.clear()
                    result.clear()
                    element.construct(classes.sumSet(), result)
            result.move(self)
    

        for i in self.elements:
            for j in i.boundaries:
                j.maximalize()
        """
    
    def sum(self,other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if other.isEmpty():
            return
        if self.isEmpty():
            self.copy(other)
                    
        self.maximalize()
        other.maximalize()
        #self.printE('+++')
        #other.printE('###')
        if self.sort.type == 'sort-attribute':
            result = coForm(self.sort)
            temp = coForm(self.sort)
            one = coForm(self.sort)
            two = coForm(self.sort)
            otherind = other.first()
            while otherind is not None:
                other.remove(otherind)
                two.insert(otherind)
                othernext = None
                
                i = other.first()
                while i is not None:
                    if i.attribute == two.elements[0].attribute:
                        if othernext is None or othernext is i:
                            othernext = other.next(i)
                        tbr = i
                        i = other.next(i)
                        other.remove(tbr)
                        two.insert(tbr)
                    else:
                        i = other.next(i)

                othermove = True
                #print('\n-----------------------------------------------------------')
                #two.printE('>>>')
                while not self.isEmpty():
                    thisind = self.first()
                    self.remove(thisind)
                    one.insert(thisind)

                    i = self.first()
                    while i is not None:
                        if i.attribute == one.elements[0].attribute:
                            tbr = i
                            i = self.next(i)
                            self.remove(tbr)
                            one.insert(tbr)
                        else:
                            i = other.next(i)
                            
                            
                    #print('===============================')
                    #one.printE('   -----')
                    classes = thisind.classification(one, two)
                    if classes.disjoint():
                        #print('@@@ disjoint')
                        one.move(temp)
                    elif classes.touches():
                        #print('@@@ touches')
                        if thisind.attribute == otherind.attribute:
                            #print('@@@@@ same attribute')
                            if othermove:
                                two.move(other)
                                othermove = False
                            else:
                                two.clear()
                            thisind.construct(classes.sumSet(), two)
                            otherind = two.first()
                            for i in two.elements:
                                i.addAttribute(thisind.attribute)
                            one.clear()
                        else:
                            #print('@@@@@ diff attribute')
                            one.move(temp)
                    elif thisind.attribute == otherind.attribute:
                        #print('@@@ else same attribute')
                        if classes.contains():
                            if othermove:
                                two.move(other)
                                othermove = False
                            one.move(temp)
                            break
                        elif classes.isContained():
                            one.clear()
                        else:
                            if othermove:
                                two.move(other)
                                othermove = False
                            else:
                                two.clear()
                            thisind.construct(classes.sumSet(), two)
                            for i in two.elements:
                                i.addAttribute(thisind.attribute)
                            otherind = two.first()
                            one.clear()
                    elif thisind.attribute.partOf(otherind.attribute):
                        #print('@@@ else part of attribute')
                        #update this by subtracting otherind from thisind
                        one.clear()
                        if not classes.isContained():
                            thisind.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(thisind.attribute)
                                one.remove(ind)
                                temp.insert(ind)
                        thisind.clear()
                    elif otherind.attribute.partOf(thisind.attribute):
                        #print('@@@ else other part of attribute')
                        one.move(temp)
                        # update otherind by subtracting thisind
                        if othermove :
                            two.move(other)
                        else: 
                            two.clear()
                        if not classes.contains():
                            otherind.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(otherind.attribute)
                            if not othermove: 
                                otherind.clear()
                            othermove = False
                            otherind = two.first()
                        else: 
                            if not othermove:
                                otherind.clear()
                            
                            othermove = False
                            break
                    else: 
                        #print('@@@ else overlapping attribute')
                        # update this by subtracting otherind from thisind
                        one.clear()
                        if not classes.isContained(): 
                            thisind.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(thisind.attribute)
                                one.remove(ind)
                                temp.insert(ind)
                        # update result with the product of otherind and thisind
                        thisind.construct(classes.productSet(), one)
                        attr = thisind.attribute.duplicate()
                        attr.sum(otherind.attribute)
                        thisind.clear()
                        while not one.isEmpty():  
                            ind = one.first()
                            ind.addAttribute(attr)
                            one.remove(ind)
                            result.insert(ind)
                        # update otherind by subtracting thisind
                        if othermove: 
                            two.move(other)
                        else: 
                            two.clear()
                        
                        if not classes.contains(): 
                            otherind.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(otherind.attribute)
                            
                            if not othermove:
                                otherind.clear()
                            
                            othermove = False
                            otherind = two.first()
                        else: 
                            if not othermove: 
                                otherind.clear()
                            othermove = False
                            break
                if othermove: 
                    result.copy(two)
                    two.move(other)
                else: 
                    two.move(result)
                otherind = othernext
                temp.move(self)
            result.move(self)
        else:
            element = self.first()
            classes = element.classification(self, other)
            if classes.disjoint():
                self.copy(other)
            elif classes.isContained():
                self.clear()
                self.copy(other)
            elif not classes.contains():
                self.clear()
                element.construct(classes.sumSet(), self)
        self.maximal = True
        
        """
    def sum(self,other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if other.isEmpty():
            return
        if self.isEmpty():
            self.copy(other)
            
        self.maximalize()
        other.maximalize()
        if self.sort.type == 'sort-attribute':
            result = coForm(self.sort)
            temp = coForm(self.sort)
            one = coForm(self.sort)
            two = coForm(self.sort)
            otherind = other.first()
            while otherind is not None:
                othernext = other.next(otherind)
                other.remove(otherind)
                two.insert(otherind)
                othermove = True
                while not self.isEmpty():
                    thisind = self.first()
                    self.remove(thisind)
                    one.insert(thisind)
                    classes = thisind.classification(one, two)
                    if classes.disjoint():
                        one.remove(thisind)
                        temp.insert(thisind)
                    elif classes.touches():
                        if thisind.attribute == otherind.attribute:
                            if othermove:
                                two.remove(otherind)
                                other.insert(otherind)
                                othermove = False
                            else:
                                two.clear()
                            thisind.construct(classes.sumSet(), two)
                            otherind = two.first()
                            otherind.addAttribute(thisind.attribute)
                            one.clear()
                        else:
                            one.remove(thisind)
                            temp.insert(thisind)
                    elif thisind.attribute == otherind.attribute:
                        if classes.contains():
                            if othermove:
                                two.remove(otherind)
                                other.insert(otherind)
                                othermove = False
                            one.remove(thisind)
                            temp.insert(thisind)
                            break
                        elif classes.isContained():
                            one.clear()
                        else:
                            if othermove:
                                two.remove(otherind)
                                other.insert(otherind)
                                othermove = False
                            else:
                                two.clear()
                            thisind.construct(classes.sumSet(), two)
                            otherind = two.first()
                            otherind.addAttribute(thisind.attribute)
                            one.clear()
                    elif thisind.attribute.partOf(otherind.attribute):
                        #update this by subtracting otherind from thisind
                        one.remove(thisind)
                        if not classes.isContained():
                            thisind.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(thisind.attribute)
                                one.remove(ind)
                                temp.insert(ind)
                        thisind.clear()
                    elif otherind.attribute.partOf(thisind.attribute):
                        one.remove(thisind)
                        temp.insert(thisind)
                        # update otherind by subtracting thisind
                        if othermove :
                            two.remove(otherind)
                            other.insert(otherind)
                        else: 
                            two.remove(otherind)
                            two.clear()
                        if not classes.contains():
                            otherind.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(otherind.attribute)
                            if not othermove: 
                                otherind.clear()
                            othermove = False
                            otherind = two.first()
                        else: 
                            if not othermove:
                                otherind.clear()
                            
                            othermove = False
                            break
                    else: 
                        # update this by subtracting otherind from thisind
                        one.remove(thisind)
                        if not classes.isContained(): 
                            thisind.construct(classes.diffSet(), one)
                            while not one.isEmpty():
                                ind = one.first()
                                ind.addAttribute(thisind.attribute)
                                one.remove(ind)
                                temp.insert(ind)
                        # update result with the product of otherind and thisind
                        thisind.construct(classes.productSet(), one)
                        attr = thisind.attribute.duplicate()
                        attr.sum(otherind.attribute)
                        thisind.clear()
                        while not one.isEmpty():  
                            ind = one.first()
                            ind.addAttribute(attr)
                            one.remove(ind)
                            result.insert(ind)
                        # update otherind by subtracting thisind
                        if othermove: 
                            two.remove(otherind)
                            other.insert(otherind)
                        else: 
                            two.remove(otherind)
                            two.clear()
                        
                        if not classes.contains(): 
                            otherind.construct(classes.otherDiffSet(), two)
                            for ind in two.elements:
                                ind.addAttribute(otherind.attribute)
                            
                            if not othermove:
                                otherind.clear()
                            
                            othermove = False
                            otherind = two.first()
                        else: 
                            if not othermove: 
                                otherind.clear()
                            othermove = False
                            break
                if othermove: 
                    two.remove(otherind)
                    other.insert(otherind)
                    result.insert(otherind)
                else: 
                    two.move(result)
                otherind = othernext
                temp.move(self)
            result.move(self)
        else:
            element = self.first()
            classes = element.classification(self, other)
            if classes.disjoint():
                self.copy(other)
            elif classes.isContained():
                self.clear()
                self.copy(other)
            elif not classes.contains():
                self.clear()
                element.construct(classes.sumSet(), self)
        self.maximal = True
        """
        
    def difference(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if other.isEmpty():
            return
        if self.isEmpty():
            return

        self.maximalize()
        other.maximalize()

        if self.sort.type == 'sort-attribute':
            result = coForm(self.sort)
            one = coForm(self.sort)
            two = coForm(self.sort)
            while not self.isEmpty():
                thisind =  self.first()
                self.remove(thisind)
                one.insert(thisind)
                otherind =  other.first()
                while otherind is not None:
                    other.remove(otherind)
                    two.insert(otherind)
                    classes = thisind.classification(one, two)
                    if classes.isContained():
                        if (thisind.attribute == otherind.attribute 
                                or thisind.attribute.partOf(otherind.attribute)):
                            one.clear()
                        else:
                            while not one.isEmpty():
                                ind =  one.first()
                                ind.attribute.difference(otherind.attribute)
                                one.remove(ind)
                                result.insert(ind)

                        two.remove(otherind)
                        other.insert(otherind)
                        break
                    elif not classes.disjoint() and not classes.touches():
                        one.remove(thisind)
                        if (not thisind.attribute == otherind.attribute
                                and not thisind.attribute.partOf(otherind.attribute)):
                            # update result with the product of otherind and thisind
                            attr = thisind.attribute.duplicate()
                            attr.difference(otherind.attribute)
                            
                            if attr == thisind.attribute:
                                one.insert(thisind)
                            else:
                                thisind.construct(classes.productSet(), one)
                                while not one.isEmpty():
                                    ind =  one.first()
                                    ind.addAttribute(attr)
                                    one.remove(ind)
                                    result.insert(ind)
                                # update one by subtracting otherind from thisind
                                thisind.construct(classes.diffSet(), one)
                                for ind in one.elements:
                                    ind.addAttribute(thisind.attribute)
                                thisind.clear()
                        else:
                            # update one by subtracting otherind from thisind
                            thisind.construct(classes.diffSet(), one)
                            for ind in one.elements:
                                ind.addAttribute(thisind.attribute)
                            thisind.clear()
                    two.remove(otherind)
                    other.insert(otherind)
                    otherind = other.next(otherind)
                one.move(result)
            result.move(self)
        else:
            element = self.first()
            classes = element.classification(self, other)
            if classes.isContained():
                self.clear()
            elif not (classes.disjoint() or classes.touches()):
                self.clear()
                element.construct(classes.diffSet(), self)
        self.maximal = True
        
        
    def product(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if other.isEmpty():
            self.clear()
            return
        if self.isEmpty():
            return
        self.maximalize()
        other.maximalize()
        
        if self.sort.type == 'sort-attribute':
            result = coForm(self.sort)
            one = coForm(self.sort)
            two = coForm(self.sort)
            while not self.isEmpty():
                thisind = self.first()
                self.remove(thisind)
                one.insert(thisind)
                otherind = other.first()
                while otherind is not None:
                    other.remove(otherind)
                    two.insert(otherind)
                    classes = thisind.classification(one, two)
                    if classes.isContained():
                        if (not thisind.attribute == otherind.attribute
                                and not thisind.attribute.partOf(otherind.attribute)):
                            thisind.attribute.product(otherind.attribute)
                        one.remove(thisind)
                        result.insert(thisind)
                        two.remove(otherind)
                        other.insert(otherind)
                        break
                    elif not classes.disjoint() and not classes.touches():
                        if (thisind.attribute == otherind.attribute
                                or thisind.attribute.partOf(otherind.attribute)):
                            attr = thisind.attribute
                        elif otherind.attribute.partOf(thisind.attribute):
                            attr = otherind.attribute
                        else:
                            attr = thisind.attribute.duplicate()
                            attr.product(otherind.attribute)
                        two.remove(otherind)
                        other.insert(otherind)
                        if classes.contains():
                            two.insert(otherind.duplicate())
                        else:
                            thisind.construct(classes.productSet(), two)
                        while not two.isEmpty():
                            ind = two.first()
                            ind.addAttribute(attr)
                            two.remove(ind)
                            result.insert(ind)
                    else:
                        two.remove(otherind)
                        other.insert(otherind)
                    otherind = other.next(otherind)
                one.clear()
            result.move(self)
        else:
            element = self.first()
            classes = element.classification(self, other)
            if classes.disjoint() or classes.touches():
                self.clear()
            elif classes.contains():
                self.clear()
                self.copy(other)
            elif not classes.isContained():
                self.clear()
                element.construct(classes.productSet(), self)
        self.maximal = False
                
    def symdifference(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if other.isEmpty():
            return
        if self.isEmpty():
            self.copy(other)
            return
        self.maximalize()
        other.maximalize()
        
        if self.sort.type == 'sort-attribute':
            pass # just find sum and product and then take the diff maybe...
        else:
            element = self.first()
            classes = element.classification(self, other)
            if classes.disjoint():
                self.copy(other)
                return
            else:
                self.clear()
                element.construct(classes.symDiffSet(), self)
                
    def partition(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if other.isEmpty():
            return coForm(self.sort)
        if self.isEmpty():
            return coForm(self.sort)
        self.maximalize()
        other.maximalize()
        common = coForm(self.sort)
        if self.sort.type == 'sort-attribute':
            pass #too many things to consider...
        else:
            element = self.first()
            classes = element.classification(self, other)
            if classes.disjoint() or classes.touches():
                pass
            elif classes.isContained():
                common.copy(self)
                self.clear()
                other.clear()
                element.construct(classes.otherDiffSet(), other)
            elif classes.contains():
                common.copy(other)
                self.clear()
                other.clear()
                element.construct(classes.diffSet(), self)
            else:
                self.clear()
                other.clear()
                element.construct(classes.diffSet(), self)
                element.construct(classes.otherDiffSet(), other)
                element.construct(classes.productSet(), common)
        return common
        
    def partOf(self, other):
        if self is other:
            raise ValueError('operation on two instances of the same form')
        if self.sort != other.sort:
            raise ValueError('operation on two forms not of the same sort')
        if self.isEmpty():
            return True
        if other.isEmpty():
            return False
            
        self.maximalize()
        other.maximalize()
        for i in self.elements:
            for j in i.boundaries:
                check = False
                for k in other.elements:
                    for l in k.boundaries:
                        if j.partOf(l):
                            check = True
                if check == False:
                    return False
        return True
        
        """
        self.maximalize()
        other.maximalize()
        element = self.first()
        classes = element.classification(self,other)
        if not classes.isContained():
            return False
        if element.sort.type == 'sort-attribute':
            one = coForm(self.sort)
            two = coForm(self.sort)
            for i in self.elements:
                one.insert(i)
                check = False
                for j in other.elements:
                    if i.attribute.partOf(j.attribute):
                        two.insert(j)
                        classes = element.classification(one,two)
                        if classes.isContained():
                            check = True
                        two.remove(j)
                if check == False:
                    return False
                one.remove(i)
        return True
        """

    """
    def containsInd(self, ind):
        other = coForm(ind.sort)
        other.insert(ind)
        classes = ind.classification(self, other)
        if not classes.contains():
            return False
        if ind.hasAttribute():
            if self.sort.type == 'sort-attribute':
                for i in self.elements:
                    if ind.attribute.partOf(i.attribute):
                        print('true')
                        return True
            print('false')
            return False
        print('true')
        return True
        """
        
    def convertFloat(self):
        result = coForm(self.sort)
        for i in self.elements:
            result.insert(i.convertFloat())
        result.maximal = self.maximal
        return result
