# -*- coding: utf-8 -*-
"""
Created on Tue Sep  6 12:36:58 2016

@author: akibdpt
"""
from ..visit.elementVisitor import elementVisitor
from .ruleAnalysis import ruleAnalysis
from .ruleApplication import ruleApplication
from ..map.similarityMap import similarityMap2D, similarityMap3D
from ..transform.transformSet import transformSet
from ..transform.affineTransform import affineTransform2D, affineTransform3D

class detection(elementVisitor):
    def __init__(self, rule):
        self.rule = rule
        
        ###############################################
        #self.analysis= ruleAnalysis(self.rule.lhs)
        self.analysis= ruleAnalysis(self.rule.lhsf)
        self.checkRefl()
        ###############################################
        
        self.form = None
        self.target = None
        self.uptrail = []
        self.downTrail = []
        self.success = False
        self.applications = []
        return
        
    def count(self):
        return len(self.applications)
        
    def getApplication(self, index = 0):
        if index >= len(self.applications):
            raise IndexError
        return self.applications[index]
        
    def matches(self):
        matches = []
        for i in self.applications:
            match = i.matchForm
            if len(matches) == 0 or match not in matches:
                matches.append(match)
        return matches
    
    def results(self, match):
        r = []
        for i in self.applications:
            if match is i.matchForm:
                r.append(i.resultForm)
        return r
        
    def checkRefl(self):
        self.clear()
        
        if similarityMap2D in self.analysis.maps:
            reflX = affineTransform2D.reflectionX()
        elif similarityMap3D in self.analysis.maps:
            reflX = affineTransform3D.reflectionX()
            
        tfS = transformSet()
        tfS.add(reflX)
        form = self.rule.lhsf.transform(tfS)
        
        self.analysis.unsetVisitedAll()
        
        fragments = self.analysis.fragments
        for i in fragments:
            self.target = i
            self.uptrail.clear()
            if self.target.content.visited:
                visit = True
                self.uptrail.append(self.target)
                while(self.uptrail[-1].parent is not None):
                    self.uptrail.append(self.uptrail[-1].parent)
                    if self.uptrail[-1].content.visited:
                        visit = False
                if visit:
                    form.accept(self)
                    self.target.content.visited = True
                    if self.target.parent is not None:
                        self.target.parent.content.visited = True
        
        for map in self.analysis.maps.values():
            potentialTrans = map.potentialTransforms()
            if potentialTrans is not None:
                for tf in potentialTrans:
                    if tf[0].type == 'transform':
                        continue
                    if tf[3] % 2 == 0:
                        continue

                    tfset = transformSet()
                    tfset.add(tf[0])
                    check = self.rule.lhsf.checkTransform(tfset, form)
                    if check:
                        self.analysis.setRefl(1)
                        print('check reflection: True')
                        return
        print('check reflection: False')
        self.analysis.setRefl(0)
        return False            
        
        
    #..................
    def detect(self, form):
        self.clear()
        ###########################
        self.form = form.convertFloat()
        ###########################
        self.analysis.unsetVisitedAll()
        fragments = self.analysis.fragments
        for i in fragments:
            self.target = i
            self.uptrail.clear()
            if self.target.content.visited:
                visit = True
                self.uptrail.append(self.target)
                while(self.uptrail[-1].parent is not None):
                    self.uptrail.append(self.uptrail[-1].parent)
                    if self.uptrail[-1].content.visited:
                        visit = False
                if visit:
                    self.form.accept(self)
                    self.target.content.visited = True
                    if self.target.parent is not None:
                        self.target.parent.content.visited = True
        
        resultForms = []   
        for map in self.analysis.maps.values():
            potentialTrans = map.potentialTransforms() ##
            if potentialTrans is not None:
                for tf in potentialTrans:
                    if tf[0].type == 'transform':
                        continue
                    
                    ###########################################################
                    #print('*************************************************')
                    #tf[0].printTransf()
                    ###########################################################
                    
                    tfset = transformSet()
                    tfset.add(tf[0])

                    check = self.rule.lhsf.checkTransform(tfset, self.form) 
                    
                    if check:
                        #print('----====----',tf[4], tf[3])
                        tlhs = self.rule.lhsf.transform(tfset) 
                        trhs = self.rule.rhsf.transform(tfset) 
                        if self.rule.type == 'ADDITIVE' and trhs.partOf(self.form):
                            continue
                        if [tlhs,trhs] in resultForms:
                            """
                            print('replicate')
                            tlhs.printE('~~~')
                            trhs.printE('===')
                            """
                            continue
                        resultForms.append([tlhs,trhs])

                        #check if rhs is a part of the current form
                        ###############################################################
                        app = ruleApplication(self.rule, tf, None, tlhs, trhs, map)
                        self.applications.append(app)
                        """
                        source = []
                        for i in tf[1]:
                            ind = self.rule.lhs.findFloatValue(i.individual)
                            source.append(ind)
                            
                        target = []
                        for i in tf[2]:
                            ind = form.findFloatValue(i.individual)
                            target.append(ind)
                        result = map.replicateTransform(source, target, tf[3])
                        for transform in result:
                            transfSet = transformSet()
                            transfSet.add(transform) 
                            tlhs = self.rule.lhs.transform(transfSet) 
                            trhs = self.rule.rhs.transform(transfSet) 
                            app = ruleApplication(self.rule, transfSet, None, tlhs, trhs)
                            self.applications.append(app)
                        """


                ###############################################################
        #self.applications.sort()
        return self.applications            
              
    def repTransform(self, app, form):
        source = []
        for i in app.misc[1]:
            ind = self.rule.lhs.findFloatValue(i.individual)
            source.append(ind)
            
        target = []
        for i in app.misc[2]:
            ind = form.findFloatValue(i.individual)
            target.append(ind)
        result = map.replicateTransform(source, target, app.misc[3])
        for transform in result:
            transfSet = transformSet()
            transfSet.add(transform) 
            tlhs = self.rule.lhs.transform(transfSet) 
            trhs = self.rule.rhs.transform(transfSet) 
            app = ruleApplication(self.rule, transfSet, None, tlhs, trhs)
            self.applications.append(app)
        return
              
              
              
    def clear(self):
        self.form = None
        for map in self.analysis.maps.values():
            map.clear()
        self.target = None
        self.uptrail = []
        self.downTrail = []
        self.success = False
        self.applications = []

    def visitEnter(self, element):
        if 'ind' in element.type:
            if len(self.uptrail) == 0:
                mapping = self.analysis.getMap(element.sort)
                result = False
                fragment = self.target.content
                for elm in fragment:
                    if mapping.map(elm, element):
                        result = True
                return result
        elif 'form' in element.type:
            if element.type == 'form-metaForm':
                return True
            elif len(self.uptrail) != 0 and element.sort != self.uptrail[-1].content.sort:
                return False
            elif len(self.uptrail) != 0:
                self.uptrail.pop(0)
                """
            else: 
                fragment = self.downTrail[-1]
                if fragment is None: 
                    fragment = self.target
                children = fragment.children
                for fragment in children:
                    if element.sort == fragment.content.sort:
                        self.downTrail.append(fragment)
                        break
                    
                if self.downTrail[-1].content.visited:
                    return False
                    """

        return True
    
    def visitLeave(self, element):
        if 'ind' in element.type:
            print('visit leave ind', element)
            if (self.success and len(self.uptrail) != 0):
                mapping = self.analysis.getMap(element.sort)
                for elm in self.uptrail[-1].parent.content:
                     mapping.map(elm, element)
                self.success = False
        elif 'form' in element.type:
            if element.type == 'form-metaForm':
                return
                """
            elif len(self.downTrail) != 0:
                self.downTrail.pop(0)
                """
            elif (len(self.uptrail) != 0 and self.uptrail[-1].parent is not None
                    and element.sort == self.uptrail[-1].parent.content.sort):
                self.uptrail.append(self.uptrail[-1].parent)
            elif element.sort == self.target.content.sort:
                self.uptrail.append(self.target)
        return