# -*- coding: utf-8 -*-
"""
Created on Tue Sep 13 09:15:18 2016

@author: akibdpt
"""
from ..transform.transformSet import transformSet
from copy import deepcopy as cp
class ruleApplication():
    
    def __init__(self, rule, tf, ps, match, result, mapping):
        self.type = 'grammar-ruleApplication' 
        self.rule = rule
        self.transformSet = tf
        self.paramSet = ps
        self.matchForm = match
        self.resultForm = result
        self.mapping = mapping
        
    def applicable(self, form):
        return self.matchForm.partOf(form)
        
    def __eq__(self, other):
        if other is None or other.type != 'grammar-ruleApplication':
            return False
        return (self.rule == other.rule and 
                self.matchForm == other.matchForm and
                self.resultForm == other.resultForm)
    
    def perform(self, form):
        source = []
        
        for i in self.transformSet[1]:
            ind = self.rule.lhs.findFloatValue(i.individual)
            if ind is False:
                print( i.individual)
                raise ValueError('individual in source set cannot be found')
            source.append(ind)

        target = []
        for i in self.transformSet[2]:
            ind = form.findFloatValue(i.individual)
            if ind is False:
                form.printE()
                print( i.individual)
                raise ValueError('individual in target set cannot be found')
            target.append(ind)

        result = self.mapping.replicateTransform(source, target, self.transformSet[3])
        for transform in result:
            transfSet = transformSet()
            transfSet.add(transform)
            
            tlhs = self.rule.lhs.transform(transfSet) 
            
            trhs = self.rule.rhs.transform(transfSet) 
            
            #self.rule.context.openTrace(self, form);
            form.difference(tlhs)
            form.sum(trhs)

            #self.rule.context.closeTrace(self, form)
        return form
    
        