# -*- coding: utf-8 -*-
"""
Created on Mon Nov  7 16:03:09 2016

@author: akibdpt
"""

class classes():
    
    INNER_1 = 0
    
    OUTER_1 = 1
    
    INNER_2 = 2
    
    OUTER_2 = 3
    
    SAME_SHARED = 4
    
    OPP_SHARED = 5
    
    CLASS_COUNT = 6
    
    def __init__(self):
        self.classes = [None for i in range(classes.CLASS_COUNT)]
        for i in range(classes.CLASS_COUNT):
            self.classes[i] = []
            
    def printClasses(self):
        for i in range(6):
            if i == 0:
                print('INNER_1:')
            elif i == 1:
                print('OUTER_1:')
            elif i == 2:
                print('INNER_2:')
            elif i == 3:
                print('OUTER_2:')
            elif i == 4:
                print('SAME_SHARED:')
            elif i == 5:
                print('OPP_SHARED:')
            for j in self.classes[i]:
                print('--', j)
            
    def addInnerOne(self, segment):
        self.classes[classes.INNER_1].append(segment)

    def addInnerTwo(self, segment):
        self.classes[classes.INNER_2].append(segment)
    
    def addOuterOne(self, segment):
        self.classes[classes.OUTER_1].append(segment)
    
    def addOuterTwo(self, segment):
        self.classes[classes.OUTER_2].append(segment)
    
    def addSameShared(self, segment):
        self.classes[classes.SAME_SHARED].append(segment)
    
    def addOppShared(self, segment):
        self.classes[classes.OPP_SHARED].append(segment)
    
    def contains(self):
        return (len(self.classes[classes.INNER_1]) == 0 and
                len(self.classes[classes.OUTER_2]) == 0 and
                len(self.classes[classes.OPP_SHARED]) == 0)
        
    
    def isContained(self):
        return (len(self.classes[classes.INNER_2]) == 0 and
                len(self.classes[classes.OUTER_1]) == 0 and
                len(self.classes[classes.OPP_SHARED]) == 0)

    def touches(self):
        return (len(self.classes[classes.INNER_1]) == 0 and
                len(self.classes[classes.INNER_2]) == 0 and
                len(self.classes[classes.SAME_SHARED]) == 0 and
                len(self.classes[classes.OPP_SHARED]) != 0)
    
    def disjoint(self):
        return (len(self.classes[classes.INNER_1]) == 0 and
                len(self.classes[classes.INNER_2]) == 0 and
                len(self.classes[classes.SAME_SHARED]) == 0 and
                len(self.classes[classes.OPP_SHARED]) == 0)
    
    def aligns(self):
        return (len(self.classes[classes.SAME_SHARED]) != 0 and
                len(self.classes[classes.OPP_SHARED]) == 0)
    
    def sumSet(self):
        result = []
        result += self.classes[classes.OUTER_1]
        result += self.classes[classes.OUTER_2]
        result += self.classes[classes.SAME_SHARED]
        return result
    
    def productSet(self):
        result = []
        result += self.classes[classes.INNER_1]
        result += self.classes[classes.INNER_2]
        result += self.classes[classes.SAME_SHARED]
        return result
    
    def diffSet(self):
        result = []
        result += self.classes[classes.OUTER_1]
        result += self.classes[classes.INNER_2]
        result += self.classes[classes.OPP_SHARED]
        return result
    
    def otherDiffSet(self):
        result = []
        result += self.classes[classes.OUTER_2]
        result += self.classes[classes.INNER_1]
        result += self.classes[classes.OPP_SHARED]
        return result
    
    def symDiffSet(self):
        result = []
        result += self.classes[classes.INNER_1]
        result += self.classes[classes.INNER_2]
        result += self.classes[classes.OUTER_1]
        result += self.classes[classes.OUTER_2]
        return result
        
        
class lineClasses():
    INNER = 0
    
    OUTER = 1
    
    SHARED = 2
    
    CLASS_COUNT = 3
    
    def __init__(self):
        self.classes = [None for i in range(lineClasses.CLASS_COUNT)]
        for i in range(lineClasses.CLASS_COUNT):
            self.classes[i] = []
            
    def printClasses(self):
        for i in range(len(self.classes)):
            if i == 0:
                print('INNER:')
            elif i == 1:
                print('OUTER_1:')
            elif i == 2:
                print('SHARED:')
            for j in self.classes[i]:
                print('--', j)
            
            
    def addInner(self, segment):
        self.classes[lineClasses.INNER].append(segment)

    def addOuter(self, segment):
        self.classes[lineClasses.OUTER].append(segment)
    
    def addShared(self, segment):
        self.classes[lineClasses.SHARED].append(segment)
    
    def isContained(self):
        return len(self.classes[lineClasses.OUTER]) == 0
        
    def isInner(self):
        return (len(self.classes[lineClasses.SHARED]) == 0 and 
                len(self.classes[lineClasses.OUTER]) == 0)
        
    def touches(self):
        return (len(self.classes[lineClasses.INNER]) == 0 and 
                len(self.classes[lineClasses.OUTER]) == 0)
    
    def disjoint(self):
        return (len(self.classes[lineClasses.INNER]) == 0 and
                len(self.classes[lineClasses.SHARED]) == 0)
                
    def innerSet(self):
        return self.classes[lineClasses.INNER]
        
    def sharedSet(self):
        return self.classes[lineClasses.SHARED]
        
    def outerSet(self):
        return self.classes[lineClasses.OUTER]
        
    def containedSet(self):
        return self.classes[lineClasses.INNER] + self.classes[lineClasses.SHARED]
        
    def notInnerSet(self):
        return self.classes[lineClasses.OUTER] + self.classes[lineClasses.SHARED]

    def notSharedSet(self):
        return self.classes[lineClasses.OUTER] + self.classes[lineClasses.INNER]